////// I2C TI Video Decoder TVP5150 Register Setting ////// 
//////     2010-03-20  Y.Fujioka                     //////
/////////////////////////////////////////////////////////// 
 
#include <16f88.h> 


#fuses INTRC_IO, NOWDT, NOPUT, NOLVP, NOBROWNOUT, NOPROTECT 
#use delay(clock=8000000) 
#use fast_io(A) 
#use fast_io(B) 
#use i2c(MASTER, SDA=PIN_B1, SCL=PIN_B4, SLOW) 
  
// I2C AhX 
// B7-B4 ̓foCXE^Cv\Ȁꍇ́@1010 (0xax) ƂȂ 
// B3-B1 ̓foCX̑Is 
// B0   ́@R/W  
//
// TĨfW^rfIGR[_@TVP5150 ̏ꍇ 
// I2C AhX@W:0xBA  R:0xBD 
 
/// Proto Type  
  
void write_vdec(int chip, long address, int data); 
int read_vdec(int chip, long address); 

 /// O[oϐA萔錾 

int chipadrs;			// IC chip address 
int addr1; 
int data1; 
int addr2; 
int data2; 

/// C֐ 
void main() 
{ 
	set_tris_a(0x00);	 		// Port A ALL Output
    	output_float(PIN_B1); 			// I2C pɐݒ
	output_float(PIN_B4); 			//
	delay_ms(100);			 	
	output_bit(PIN_A0, 0);			// Chip Reset 
    	delay_ms(100); 				// timer
	output_bit(PIN_A0, 1); 			// 
	chipadrs = 0xba;			// `bvAhXw 
	addr1 = 0x03; 				// WX^AhXw
    	data1 = 0xef; 				// VBKO => VBLK
						// GPCL => Output
						// GPCL ENABLE
						// YCbCR => active
						// HSYNC, VSYNC, AVID, FID => Active
						// VBLK => On
						// SCLK => Enable

	addr2 = 0x0f; 				//@WX^AhXw
    	data2 = 0x02; 				// VSYNC, VBLK, SCLK enable

	write_vdec(chipadrs, addr1, data1);  // ݒ 1 
	delay_ms(100); 
	write_vdec(chipadrs, addr2, data2);  // ݒ 2
    	delay_ms(100); 
	while(1) 
	{ 
	} 
} 
 

  
 //// Video Decoder ݊֐ 
 void write_vdec(int chip, long address, int data) 
 { 
	i2c_start(); 

 	i2c_write(chip);			// write mode 
	i2c_write(address);			// lower address 
	i2c_write(data);			// data 
	i2c_stop(); 		
	delay_ms(5);				// Write Cycle time		 
 } 


 //// Video Decoder ǂݏo֐ 
 int read_vdec(int chip, long address) 
{ 
 	int data; 

 	i2c_start(); 
	i2c_write(chip);			// write mode 
 	i2c_write(address);			// lower address	 
 	i2c_stop(); 
 	delay_us(20); 
	i2c_start(); 
	i2c_write(chip | 0x01);			// read mode 
 //	i2c_write(chip | 0x00);			// read mode 
 	data=i2c_read(0);			// get data with no ACK 
 	i2c_stop(); 
 	return(data); 
 } 

 
 
 
  
